import unittest
import enum

from ldapserver.rfc4518_stringprep import prepare, MatchingType, SubstringType

class TestStringprep(unittest.TestCase):
	def test_map(self):
		self.assertEqual(prepare('foo\n\rbar', MatchingType.EXACT_STRING, SubstringType.NONE), ' foo  bar ')
		self.assertEqual(prepare('foo\u200Bbar', MatchingType.EXACT_STRING, SubstringType.NONE), ' foobar ')

	# TODO: systematic test cases

	def test_examples(self):
		# Examples from RFC4518 for "Insignificant Character Handling"
		self.assertEqual(prepare('foo bar  ', MatchingType.EXACT_STRING, SubstringType.NONE), ' foo  bar ')
		self.assertEqual(prepare('foo bar  ', MatchingType.EXACT_STRING, SubstringType.INITIAL), ' foo  bar ')
		self.assertEqual(prepare('foo bar  ', MatchingType.EXACT_STRING, SubstringType.ANY), 'foo  bar ')
		self.assertEqual(prepare('  123  456  ', MatchingType.NUMERIC_STRING), '123456')
		self.assertEqual(prepare('   ', MatchingType.NUMERIC_STRING), '')
		self.assertEqual(prepare(' -123  456 -', MatchingType.TELEPHONE_NUMBER), '123456')
		self.assertEqual(prepare('---', MatchingType.TELEPHONE_NUMBER), '')
